function [niter Phi]=Slapl_19(Uup,Udwn,Ndiv)
U1=Uup;
U0=Udwn;
L=1;
N=Ndiv;
er=10.e-4;
UboundAver=(U1*(N+1)+(4*N-(N+1))*U0)/(4*N);
Phi=zeros(N+1,N+1);
%Setting boundary conditions
Phi(:,N+1)=U1;
%Phi(:,11)
Phi(1,1:N)=U0;
Phi(N+1,1:N)=U0;
Phi(2:N,1)=U0;
PhiN=Phi;
%Setting initial values to internal nodes
for i=2:N 
    for j=2:N
        Phi(i,j)=UboundAver;
    end
end

%position and size of the floating electrode
iul=N-12; %upper left corner with lowest indices
jul=18;
Ne=2; 

%Calculating new values of potential 
niter=0;
est=2*er;
while (niter==0 || est>er)
    
    for j=2:N 
       for i=2:N
           PhiN(i,j)=0.25*(Phi(i-1,j)+Phi(i+1,j)+Phi(i,j-1)+Phi(i,j+1));
       end
    end
%Calculations for floating electrode 
Phielav=0;
   for iel=0:Ne
Phielav=Phielav+PhiN(iul-1,jul+iel)+PhiN(iul+Ne+1,jul+iel)+PhiN(iul+iel,jul-1)+PhiN(iul+iel,jul+Ne+1);
   end 
   Phielav=Phielav/(4*(Ne+1));
PhiN(iul:iul+Ne,jul:jul+Ne)=Phielav;
    
    niter=niter+1;
    dPhi=abs((PhiN(2:N,2:N)-Phi(2:N,2:N))./PhiN(2:N,2:N));
    est=abs(max(max(dPhi)));
    Phi=PhiN;
end
Phielav
contourf(Phi)
%surfc(Phi)
%[x1 y1]=meshgrid(linspace(0,L,N+1),linspace(0,L,N+1));
%surfc(y1,x1,Phi)
%contour(y1,x1,Phi)
hold on 
%plot FE
%plot([iul iul iul+Ne iul+Ne iul], [jul jul+Ne jul+Ne jul jul],'o-')
plot([jul jul+Ne jul+Ne jul jul],[iul iul iul+Ne iul+Ne iul],'o-')
hold off
end