%Dirichlet problem
tic;
N=20;
U1=100;
U0=0;
epsi=0.0001;
Phi=zeros(N+1,N+1);
PhiN=zeros(N+1,N+1);
dPhi=zeros(N-1,N-1);
for i=1:N+1
   Phi(i,N+1)=U1;
   Phi(i,1)=U0;
end
for j=2:N
   Phi(1,j)=0;
   Phi(N+1,j)=0;
end
Phi_av=(U0*(3*N-1)+U1*(N+1))/(4*N);
%set init pot in inner nodes: here average of the electrodes pot
for i=2:N
   for j=2:N
      Phi(i,j)=Phi_av;
   end
end
PhiN=Phi;

niter=0;
err=1;
while err>=epsi
   %relaxation solution of Dirichlet problem
   %sweep along plates, i.e. first index changing
   err=0;
   for j=2:N
      for i=2:N
         PhiN(i,j)=0.25*(Phi(i-1,j)+Phi(i+1,j)+Phi(i,j-1)+Phi(i,j+1));
         dPhi(i,j)=PhiN(i,j)-Phi(i,j);
         err=max(err,abs(dPhi(i,j))/abs(Phi(i,j)));
      end
   end
   Phi=PhiN;
   niter=niter+1;
   end %while
toc
niter
%mesh(Phi)
contour(Phi)
