%Dirichlet problem by vectorization
tic;
N=20;
U1=100;
U0=0;
epsi=0.0001;
Phi=zeros(N+1,N+1);
%dPhi=zeros(N-1,N-1);
Phi(:,N+1)=U1*ones(N+1,1);
Phi(:,1)=U0*ones(N+1,1);
Phi(1,2:N)=U0*ones(1,N-1);
Phi(N+1,2:N)=U0*ones(1,N-1);

PhiN=Phi;
%input(' ');

Phi_av=(U0*(3*N-1)+U1*(N+1))/(4*N);
%set init pot in inner nodes: here average of the electrodes pot
Phi(2:N,2:N)=Phi_av*ones(N-1,N-1);
Phiin=Phi(2:N,2:N);
%input(' ');

niter=0;
err=1;
while err>=epsi
   %relaxation solution of Dirichlet problem
   %sweep along plates, i.e. first index changing
   
   PhiNin=0.25*(Phi(1:N-1,2:N)+Phi(3:N+1,2:N)+Phi(2:N,1:N-1)+Phi(2:N,3:N+1));
%size(Phi)
%size(PhiN)

%input(' ');

   err=max(max(abs(PhiNin-Phiin)./abs(Phiin)));
   Phi(2:N,2:N)=PhiNin;
   Phiin=PhiNin;
   niter=niter+1;
end %while
toc
niter
%mesh(Phi)
contour(Phi)
