%earth1
clear all
tic
G=6.67e-11;
M=6e24;
R=6.4e6;
th0=54*pi/180;
phi0=82*pi/180;
al0=20*pi/180;
bet0=10*pi/180;
w=2*pi/(24*60*60);
m=1e3;
vo=6.5e3;
Vrot=w*R*cos(th0);
Xo=R*cos(th0)*cos(phi0);
Yo=R*cos(th0)*sin(phi0);
Zo=R*sin(th0);

Vor=vo*sin(al0);
Voth=-vo*cos(al0)*cos(bet0);
Voph=vo*cos(al0)*sin(bet0)+Vrot;

Vox=Vor*cos(th0)*cos(phi0)-Voth*sin(th0)*cos(phi0)-Voph*sin(phi0);
Voy=Vor*cos(th0)*sin(phi0)-Voth*sin(th0)*sin(phi0)+Voph*cos(phi0);
Voz=Vor*sin(th0)+Voth*cos(th0);

Aox=-G*M*Xo/(Xo^2+Yo^2+Zo^2)^(3/2);
Aoy=-G*M*Yo/(Xo^2+Yo^2+Zo^2)^(3/2);
Aoz=-G*M*Zo/(Xo^2+Yo^2+Zo^2)^(3/2);

x(1)=Xo; y(1)=Yo; z(1)=Zo;
vx(1)=Vox; vy(1)=Voy; vz(1)=Voz;
ax(1)=Aox; ay(1)=Aoy; az(1)=Aoz;
dt=0.3;
t(1)=0;
i=1;
   while i==1 | sqrt(x(i)^2+y(i)^2+z(i)^2)>R 
      ax(i)=-G*M*x(i)/((x(i)^2+y(i)^2+z(i)^2)^(3/2));
      ay(i)=-G*M*y(i)/((x(i)^2+y(i)^2+z(i)^2)^(3/2));
      az(i)=-G*M*z(i)/((x(i)^2+y(i)^2+z(i)^2)^(3/2));
      
      vx(i+1)=vx(i)+ax(i)*dt;
      vy(i+1)=vy(i)+ay(i)*dt;
      vz(i+1)=vz(i)+az(i)*dt;
      
      x(i+1)=x(i)+vx(i)*dt;
      y(i+1)=y(i)+vy(i)*dt;
      z(i+1)=z(i)+vz(i)*dt;
      
      t(i+1)=t(i)+dt;
      %xk=x(i+1);
      %yk=y(i+1);
      RL=[x(i+1);y(i+1);z(i+1)];
      i=i+1;
   end
   
toc
nx=x/R; ny=y/R; nz=z/R;
scatter3(nx,ny,nz)
hold on
sphere(36)
hold off
bet0
al0
[Xo Yo Zo]
max(t)
