%auxilliary program for analitic calculation of entities involved
%in calculations 

clear all
clc
syms x y R1 R2 d n1 n2 n3 b x1 y1 xh yh delt1 al1 bet1 gam1 real
syms x2 y2 delt2 al2 bet2 gam2 real
%lens's surfaces
Y1=sqrt(R1^2-x^2)
Y2=sqrt(R2^2-(x-R1-R2+d)^2)

%intercection of the lens's surfaces
xh=simplify(solve(Y1-Y2,x))
yh=simplify(subs(Y2,x,xh))

%intercection of the ray b with the front lens's surface
%x1=solve(Y2-b,x) %and take smaller root

x1=R2-d+R1-(R2^2-b^2)^(1/2)
y1=b

%consider refraction on the front lens's surface
delt1=simplify(atan(subs(diff(Y2,x),x,x1)))
al1=pi/2-delt1
bet1=asin(sin(al1)*n1/n2)
gam1=simplify(al1-bet1)

%ray inside the lens
YR2=simplify(-tan(gam1)*(x-x1)+y1)

%search intercection with the rear lens's surface
%x2=simplify(solve(YR2-Y1,x)) and take greater root

x2=(R1+R2-d-(R2^2-b^2)^(1/2)+b*tan(atan((R2^2-b^2)^(1/2)/abs(b))+asin(n1/n2*abs(b/R2)))+tan(atan((R2^2-b^2)^(1/2)/abs(b))+asin(n1/n2*abs(b/R2)))*(-b^2*tan(atan((R2^2-b^2)^(1/2)/abs(b))+asin(n1/n2*abs(b/R2)))^2+R1^2*tan(atan((R2^2-b^2)^(1/2)/abs(b))+asin(n1/n2*abs(b/R2)))^2+2*R2*(R2^2-b^2)^(1/2)+2*R1*(R2^2-b^2)^(1/2)-2*d*(R2^2-b^2)^(1/2)+2*(R2^2-b^2)^(1/2)*b*tan(atan((R2^2-b^2)^(1/2)/abs(b))+asin(n1/n2*abs(b/R2)))+2*d*b*tan(atan((R2^2-b^2)^(1/2)/abs(b))+asin(n1/n2*abs(b/R2)))-2*R2*b*tan(atan((R2^2-b^2)^(1/2)/abs(b))+asin(n1/n2*abs(b/R2)))-2*R1*b*tan(atan((R2^2-b^2)^(1/2)/abs(b))+asin(n1/n2*abs(b/R2)))-2*R2^2+b^2-d^2-2*R1*R2+2*R1*d+2*R2*d)^(1/2))/(tan(atan((R2^2-b^2)^(1/2)/abs(b))+asin(n1/n2*abs(b/R2)))^2+1);
y2=subs(Y1,x,x2)
   %try obtain shorter result by introducing gam1a and YRa
   syms gam1a positive
   syms x1a y1a
   YR2a=simplify(-tan(gam1a)*(x-x1a)+y1a)
   x2a=simplify(solve(YR2a-Y1,x))

%consider refraction on the rear lens's surface
%delt2=simplify(-atan(subs(diff(Y1,x),x,x2)))
syms x2a y2a gam2a
delt2a=-atan(subs(diff(Y1,x),x,x2a))
delt2=-atan(subs(diff(Y1,x),x,x2))
al2=pi/2-(delt2-gam1);
bet2=asin(sin(al2)*n2/n3);
gam2=bet2-(pi/2-delt2)

%ray after the lens
YR3=-tan(gam2)*(x-x2)+y2

YR3a=-tan(gam2a)*(x-x2a)+y2a
%syms 
x3a=solve(YR3a,x)